package redactableBlockchain;

import at.tugraz.iaik.p2p.commons.CommonCrypto;
import at.tugraz.iaik.p2p.pol.NetworkNode;
import at.tugraz.iaik.p2p.skad.config.Config;
import redactableBlockchain.data.IBlock;
import redactableBlockchain.data.transaction.PaymentTransaction;
import redactableBlockchain.exception.VerificationException;
import redactableBlockchain.util.Constants;

import java.security.NoSuchAlgorithmException;
import java.security.spec.InvalidKeySpecException;

public class BlockchainNode {

    public UnoptimizedRedactableBlockChainImpl blockchain = null;
    public Wallet myRandomWallet;
    public static PaymentTransaction genesisTransaction;
    //	public static INetwork network = null;
    public Miner miner;
    public NetworkNode networkNode;

    public BlockchainNode(boolean print, int port) throws NoSuchAlgorithmException, InvalidKeySpecException, VerificationException {
        this.blockchain = new UnoptimizedRedactableBlockChainImpl(print, false);
        init(port);
    }
    public BlockchainNode(boolean print, int port, boolean createDot) throws NoSuchAlgorithmException, InvalidKeySpecException, VerificationException {
        this.blockchain = new UnoptimizedRedactableBlockChainImpl(print, createDot);
        init(port);
    }
    private void init(int port) throws NoSuchAlgorithmException, InvalidKeySpecException, VerificationException {
        myRandomWallet = Constants.getRandomWallet();
        blockchain.addBlock(Constants.getGenesisBlock());

        miner = new Miner(blockchain, myRandomWallet.getPublicKey(), 1);
        IBlock blockToMine = blockchain.getBlockTemplate();
        miner.notifyNewBlockToMine(blockToMine);//(Constants.getGenesisBlock());
        //miner.notifyAddedBlock(Constants.getGenesisBlock());
        blockchain.addListener(miner);

        Config conf = KotlinUtils.getConfig(port);
        this.networkNode = new NetworkNode(conf, blockchain);
    }

//    public BlockchainNode(UnoptimizedRedactableBlockChainImpl blockchain) throws NoSuchAlgorithmException, InvalidKeySpecException, VerificationException {
//
//        this.blockchain = blockchain;
//        init();
////        blockchain.addListener(network);
////        System.out.println("Starting mining...");
////        miner.start();
//
////        waitForEnd();
//    }

    public UnoptimizedRedactableBlockChainImpl getBlockchain() {
        return blockchain;
    }

    public Wallet getMyRandomWallet() {
        return myRandomWallet;
    }

    public Miner getMiner() {
        return miner;
    }
}
