package redactableBlockchain;

import java.security.NoSuchAlgorithmException;
import java.security.spec.InvalidKeySpecException;

import redactableBlockchain.data.Block;
import redactableBlockchain.data.IBlock;
import redactableBlockchain.data.CorrectionBlock;
import redactableBlockchain.data.StandardBlock;
import redactableBlockchain.exception.VerificationException;

public interface IBlockChain extends Observable
{
	StandardBlock getGenesisBlock() throws NoSuchAlgorithmException, InvalidKeySpecException;

	Block getLastBlock();

	IBlock getBlock(String hash);

	void addBlock(Block block) throws VerificationException, NoSuchAlgorithmException, InvalidKeySpecException; //return if known?

	void addModifyBlock(CorrectionBlock block) throws VerificationException, NoSuchAlgorithmException, InvalidKeySpecException;//return if known?

	IBlock getBlockTemplate();

	void addListener(IBlockChainListener listener);

}