package redactableBlockchain;

import java.math.BigInteger;
import java.security.NoSuchAlgorithmException;
import java.security.PublicKey;
import java.security.spec.InvalidKeySpecException;
import java.util.Observer;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import redactableBlockchain.data.IBlock;
import redactableBlockchain.data.CorrectionBlock;
import redactableBlockchain.data.StandardBlock;
import redactableBlockchain.data.transaction.PaymentTransaction;
import redactableBlockchain.exception.VerificationException;
import redactableBlockchain.util.Constants;
import redactableBlockchain.util.StringUtil;

public class Miner implements IBlockChainListener{

	private final Thread minerThread;
	private IBlock block = null;
	private int sleep = 0;
	private boolean mine = false;
	private static Logger logger = LoggerFactory.getLogger(Miner.class);
	public static BigInteger max = new BigInteger("ffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffff", 16);
	//	private PublicKey coinBaseAddress = null;

	public Miner(IBlockChain blockchain,PublicKey coinBaseAddress, int sleep) throws NoSuchAlgorithmException, InvalidKeySpecException
	{
		this.sleep = sleep;
		minerThread = new Thread() 
		{
			public void run() {
				logger.debug("Miner thread run....");
				int difficulty = 16*16*16;
				BigInteger result = max;
				BigInteger target = max.divide(BigInteger.valueOf(difficulty));
				//				int nonce = 0;
				while(mine == true)
				{
					result = max;
					//				block.mineBlock(16*16*16);
					if(block != null)
					{
						String hash= null;
						int nonce = 0;

						//						block.prepareBlockForMining();
						//						System.out.println("Before while loop");
						while(result.compareTo(target) > 0 && mine == true) {
							try {
								Thread.sleep(sleep);
							} catch (InterruptedException e) {e.printStackTrace();}
							if(block != null)
							{
								String prefix = null;
								if(block instanceof StandardBlock)
								{
									StandardBlock b = (StandardBlock) block;
									prefix = b.getPreviousBlockHash() + b.lastRedactionBlockHash + Long.toString(b.timeStamp);
								}
								else if(block instanceof CorrectionBlock)
								{
									CorrectionBlock b = (CorrectionBlock) block;
									prefix = b.getPreviousBlockHash() +
//											b.getPreviousBlockChain1Hash() +
//											b.getSubsequentBlockChain1Hash() +
											b.getLastBlockChain1Hash() +
											Long.toString(b.timeStamp);
								}
								nonce ++;
								hash = calculateHash(prefix, nonce, block.getMerkleRoot());
								result = new BigInteger(hash, 16);
								//															System.out.println("hash:"+hash);
							}
						}
						//											System.out.println("After while loop");
						if(result.compareTo(target) < 0 && block.getMerkleRoot() != null)
						{
							block.setNonce(nonce);
							//							logger.info("Block Mined!!! : " + hash+" nonce:"+nonce);
							logger.info("Block Mined!!! : " + block.calculateHash()+" nonce:"+nonce + " "+block);
							try {
								logger.debug("hash:"+hash+" "+block.calculateHash());
								if(block instanceof StandardBlock)
									blockchain.addBlock((StandardBlock)block);
								else if(block instanceof CorrectionBlock)
									blockchain.addModifyBlock((CorrectionBlock) block);
								result = max;
								hash ="";
								//block = null;
							} catch (NoSuchAlgorithmException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							} catch (InvalidKeySpecException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							} catch (VerificationException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
						}
					}
					else
					{
						try {
							Thread.sleep(500);
						} catch (InterruptedException e) {e.printStackTrace();}
					}

				}
				logger.debug("Miner thread end....");
			}

			public String calculateHash(String prefix, int nonce, String merkleRoot) {
				String calculatedhash = StringUtil.applySha256( 
						prefix +
						Long.toString(nonce) + 
						merkleRoot
						);
				return calculatedhash;
			}
		};

	}

	public void start()
	{
		mine = true;
		minerThread.start();
	}

	public void stop()
	{
		mine = false;
	}



	@Override
	public void notifyMissingBlock(String blockHash) {
		// Don't care for missing blocks...

	}

	@Override
	public void notifyAddedBlock(StandardBlock block) {
		// Don't care for added blocks... => only notifyNewLongestChain
	}

	@Override
	public void notifyNewLongestChain(IBlock block) {
		
	}

	@Override
	public void notifyAddedRedactionBlock(CorrectionBlock block) {
		//don't care ..or?
		//TODO
		//where do it get last redaction block form
		//how do know when to create redactionblock?
	}

	@Override
	public void notifyNewBlockToMine(IBlock block) {
		this.block = block;
	}

}
