package redactableBlockchain;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.UnknownHostException;
import java.security.NoSuchAlgorithmException;
import java.security.Security;
import java.security.spec.InvalidKeySpecException;
import java.util.HashMap;

import redactableBlockchain.data.IBlock;
import redactableBlockchain.data.transaction.PaymentTransaction;
import redactableBlockchain.data.transaction.TransactionOutput;
import redactableBlockchain.exception.VerificationException;
import redactableBlockchain.network.INetwork;
//import redactableBlockchain.network.netty.NetworkClient;
import redactableBlockchain.util.Constants;

public class UnoptimizedRedactableBlockchain {

	public static UnoptimizedRedactableBlockChainImpl blockchain = null;
	public static HashMap<String,TransactionOutput> UTXOs = new HashMap<String,TransactionOutput>();
	
	public static int difficulty = 16*16*16;
	public static int minimumTransaction = 1;
	public static Wallet walletA;
	public static Wallet walletB;
	public static Wallet myRandomWallet;
	public static PaymentTransaction genesisTransaction;
	public static INetwork network = null;
	public static Miner miner;
	public static void main1(String[] args) throws UnknownHostException, IOException, NoSuchAlgorithmException, InvalidKeySpecException, InterruptedException, VerificationException {
		try{
		//add our blocks to the blockchain ArrayList:
		Security.addProvider(new org.bouncycastle.jce.provider.BouncyCastleProvider()); //Setup Bouncey castle as a Security Provider
		myRandomWallet = Constants.getRandomWallet();
		blockchain = new UnoptimizedRedactableBlockChainImpl(true);
		blockchain.addBlock(Constants.getGenesisBlock());
//		new Wallet();
		
//		network = new NetworkClient(blockchain);
		
		miner = new Miner(blockchain, myRandomWallet.getPublicKey(),1);
		IBlock blockToMine = blockchain.getBlockTemplate();
		miner.notifyNewBlockToMine(blockToMine);//(Constants.getGenesisBlock());
		//miner.notifyAddedBlock(Constants.getGenesisBlock());
		blockchain.addListener(miner);
		blockchain.addListener(network);
		System.out.println("Starting mining...");
		miner.start();
		
		waitForEnd();
		
		}catch(Exception e)
		{
			e.printStackTrace();
		}
		
		finally
		{
//			simpleSerializingStorage.close();
			miner.stop();
		}
	}
	
private static void waitForEnd() {
	
	boolean loop = true;
	InputStreamReader isr = null;
	BufferedReader br = null;
	try {
		isr = new InputStreamReader(System.in);
	 	br = new BufferedReader(isr);
		while (loop) {
			String userInput = br.readLine();
			System.out.println("input => "+userInput);
			if (userInput.equalsIgnoreCase("quit") || userInput.equalsIgnoreCase("exit") || userInput.equalsIgnoreCase("bye")) {
				System.exit(0);
			}
		}
	}
	catch (Exception er) {
		er.printStackTrace();
		loop = false;
	}
	finally {
		try { br.close(); } catch (Exception e) {}
		try { isr.close(); } catch (Exception e) {}
	}
		
	}
	
}
