package redactableBlockchain.data;

import java.math.BigInteger;
import java.security.NoSuchAlgorithmException;
import java.security.spec.InvalidKeySpecException;
import java.util.ArrayList;

import redactableBlockchain.data.transaction.Transaction;
import redactableBlockchain.exception.BlockInvalidException;
import redactableBlockchain.exception.VerificationException;

public interface IBlock {

	static BigInteger max = new BigInteger("ffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffff", 16);
	public String calculateHash();//public String calculateHash();
	public boolean addTransaction(Transaction transaction) throws VerificationException;
	public String getPreviousBlockHash();
	public ArrayList<Transaction> getTransactions();
	public long getCreationTime();
	/*
	 * basic check that block is valid, e.g. first tx is coinbase, only one coinbase, only one voting
	 */
	public void validate() throws BlockInvalidException;
	public BigInteger getDiff();
	public String getMerkleRoot();
	public void setNonce(long nonce);
}
