package redactableBlockchain.data;

import java.security.NoSuchAlgorithmException;
import java.security.spec.InvalidKeySpecException;
import java.util.ArrayList;

import redactableBlockchain.data.transaction.Transaction;
import redactableBlockchain.exception.VerificationException;
import redactableBlockchain.util.StringUtil;

public class VirtualBlock extends Block {

	String previousHash;
	String lastRedactionBlockHash;

	public VirtualBlock(String hash, String previousHash, String lastRedactionBlockHash,ArrayList<Transaction> transactions, long timeStamp) {
		super(BlockType.FakeBlock);
		this.hash = hash;
		this.previousHash = previousHash;
		this.transactions = transactions;
		this.timeStamp = timeStamp;
		this.lastRedactionBlockHash = lastRedactionBlockHash;
	}

	@Override
	public String calculateHash() {
		return hash;
	}

	@Override
	public boolean addTransaction(Transaction transaction) throws VerificationException {
		if(transaction == null) return false;		

		transactions.add(transaction);
//		logger.info("Transaction Successfully added to Block");
		merkleRoot = StringUtil.getMerkleRoot(transactions);
		return true;
	}

	@Override
	public String getPreviousBlockHash() {
		// TODO Auto-generated method stub
		return previousHash;
	}


	@Override
	public void validate() {
		// TODO Auto-generated method stub

	}
	
	@Override
	public String toString() {
		return "FBlock [hash="+hash+", previousHash=" + previousHash + ", lastRedactionBlockHash=" + lastRedactionBlockHash
				+ ", merkleRoot=" + merkleRoot + ", transactions=" + transactions + ", timeStamp="
				+ timeStamp + ", nonce=" + nonce +"]";
	}

	public String getLastRedactionBlockHash() {
		return lastRedactionBlockHash;
	}
	
	
}
