package redactableBlockchain.data.transaction;
import java.io.Serializable;
import java.security.*;
import java.security.spec.InvalidKeySpecException;
import java.util.ArrayList;
import java.util.Arrays;

import org.bouncycastle.util.encoders.Base64;

import redactableBlockchain.data.TransactionType;
import redactableBlockchain.exception.VerificationException;
import redactableBlockchain.util.Constants;
import redactableBlockchain.util.StringUtil;
import redactableBlockchain.util.Utils;

//TODO
//currently it is assumed that all inputs belong to the same address
public class PaymentTransaction extends Transaction implements Serializable{

	private static final long serialVersionUID = -3315802965986667712L;
//	private String proof;//signature
	
	private String hash = null;
	// Constructor: 
	public PaymentTransaction(String sender, ArrayList<TransactionInput> inputs, ArrayList<TransactionOutput> outputs) throws NoSuchAlgorithmException, InvalidKeySpecException {
		super(TransactionType.PAYMENT);
		this.sender = sender;
		this.inputs = inputs;
		this.outputs = outputs;
	}

	public boolean processTransaction() throws VerificationException {

		if(verifySignature() == false) {
			System.out.println("#Transaction Signature failed to verify");
			return false;
		}
		//TODO double spending? 
		//money owned?

		return true;
	}

	public long getInputsValue() {
		long total = 0;
		//		for(TransactionInput i : inputs) {
		//			if(i.UTXO == null) continue; //if Transaction can't be found skip it, This behavior may not be optimal.
		//			total += i.UTXO.value;
		//		}
		return total;
	}

	//	public void generateSignature(PrivateKey privateKey) {
	//		String data = sender + recipient + Integer.toString(value);
	//		signature = StringUtil.applyECDSASig(privateKey,data);		
	//	}

	//	public boolean verifySignature() throws NoSuchAlgorithmException, InvalidKeySpecException {
	//		String data = sender + recipient + Integer.toString(value);
	//		PublicKey publicKeySender = Utils.PublicKeyFromBase64(sender);
	//		return StringUtil.verifyECDSASig(publicKeySender, data, signature);
	//	}

	public long getOutputsValue() {
		long total = 0;
		//		for(TransactionOutput o : outputs) {
		//			total += o.value;
		//		}
		return total;
	}

	@Override
	public String calculateHash() {
		if(hash == null)
		{
			StringBuilder sb = new StringBuilder();
			sb.append(uuid);
			sb.append(data);
			sb.append("inputs:");
			if(inputs != null)
				for(TransactionInput input : inputs)
					sb.append(input.calculateHash());
			for(TransactionOutput output : outputs)
				sb.append(output.calculateHash());
			hash =  StringUtil.applySha256(sb.toString());
		}
		return hash;
	}

	public void setSignature(byte[] sig) {
		this.signature = sig;
		hash = null;
		calculateHash();//hack for genesisblock to always get the same hash
	}

	@Override
	protected void specificChecks() throws VerificationException {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "PaymentTransaction [txId=" + calculateHash() + ", inputs=" + inputs + ", outputs="
				+ outputs + ", uuid=" + uuid + ", signature=" /*+ Arrays.toString(signature) */+ "]";
	}

}
