package redactableBlockchain.data.transaction;

import java.io.Serializable;

import redactableBlockchain.util.StringUtil;

public class TransactionInput implements Serializable{

	private static final long serialVersionUID = 666072707762089370L;

	private String transactionOutputId; //Reference to TransactionOutputs -> transactionId / hash
	//public TransactionOutput UTXO; //Contains the Unspent transaction output
//	private String proof;//signature
	private int index = -1;
	
	private String hash = null;

	public TransactionInput(String transactionOutputId, int index) {//, String proof) {
		this.transactionOutputId = transactionOutputId;
		this.index = index;
//		this.proof = proof;
		this.hash = calculateHash();
	}

	public String calculateHash() {
		if(hash != null)
			return hash;
		return StringUtil.applySha256(
				transactionOutputId +
				index //+
				//proof
				);
	}

	/**
	 * @return the transactionOutputId
	 */
	public final String getTransactionOutputId() {
		return transactionOutputId;
	}

	/**
	 * @return the proof
	 */
//	public final String getProof() {
//		return proof;
//	}

	/**
	 * @return the index
	 */
	public final int getIndex() {
		return index;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "TxIn [txId=" + transactionOutputId + ", index=" + index + "]";
	}

	
	//	public long[] getClaimedTransactionHash() {
	//		// TODO
	//		return null;
	//	}
	//
	//	public Object getClaimedOutputIndex() {
	//		// TODO 
	//		return null;
	//	}
}
