package redactableBlockchain.data.transaction;

import java.util.ArrayList;

import redactableBlockchain.util.StringUtil;

public class VoteQuestion {

	String hashOfBlockToReplace;
	String hashOfPreviousBlock;
	String hashOfSubsequentBlock;
	ArrayList<Transaction> txs;
	long timeStamp;
	public VoteQuestion(String hashOfBlockToReplace, String hashOfPreviousBlock, String hashOfSubsequentBlock, long timeStamp, ArrayList<Transaction> txs)
	{
		this.hashOfBlockToReplace = hashOfBlockToReplace;
		this.hashOfPreviousBlock = hashOfPreviousBlock;
		this.hashOfSubsequentBlock = hashOfSubsequentBlock;
		this.timeStamp = timeStamp;
		this.txs = txs;
	}
	public final String getHashOfBlockToReplace() {
		return hashOfBlockToReplace;
	}
	public final String getHashOfPreviousBlock() {
		return hashOfPreviousBlock;
	}
	public final String getHashOfSubsequentBlock() {
		return hashOfSubsequentBlock;
	}
	public final long getTimeStamp() {
		return timeStamp;
	}
	
	public final ArrayList<Transaction> getTxs() {
		return txs;
	}
	
	public String calculateHash() {
		return StringUtil.applySha256(
				hashOfBlockToReplace +
				hashOfPreviousBlock +
				hashOfSubsequentBlock +
				timeStamp//TODO add txs
				);
	}

	@Override
	public String toString() {
		return "VoteQuestion{" +
				"hashOfBlockToReplace='" + hashOfBlockToReplace + '\'' +
				", hashOfPreviousBlock='" + hashOfPreviousBlock + '\'' +
				", hashOfSubsequentBlock='" + hashOfSubsequentBlock + '\'' +
				", txs=" + txs +
				", timeStamp=" + timeStamp +
				'}';
	}
}
