package redactableBlockchain.data.transaction;

import java.io.Serializable;
import java.security.NoSuchAlgorithmException;
import java.security.PrivateKey;
import java.security.spec.InvalidKeySpecException;

import redactableBlockchain.data.TransactionType;
import redactableBlockchain.exception.VerificationException;
import redactableBlockchain.util.StringUtil;

public class VotingTransaction extends Transaction implements Serializable{

	/**
	 * 
	 */
	private static final long serialVersionUID = -5959118680909003804L;
	private String hashOfElectionTX;
	private boolean approval;
	
	public VotingTransaction(String sender, String hashOfElectionTX, boolean approval)
	{
		super(TransactionType.VOTE);
		assert(hashOfElectionTX != null);
		this.hashOfElectionTX = (hashOfElectionTX);
		this.approval = (approval);
		this.sender = sender;
	}

	public String getHashOfElectionTX() {
		return hashOfElectionTX;
	}

	public boolean isApproval() {
		return approval;
	}

	@Override
	public String calculateHash() {
		String data = sender + approval+ hashOfElectionTX + transactionType;
		return StringUtil.applySha256(data);
	}

//	public void generateSignature(PrivateKey privateKey) {
//		String data = sender + approval;//TODO
//		signature = StringUtil.applyECDSASig(privateKey,data);		
//	}
	
	@Override
	protected void specificChecks() throws VerificationException {
		// TODO Auto-generated method stub
		
	}

	@Override
	public boolean processTransaction() throws VerificationException {
//		if(verifySignature() == false) {
//			System.out.println("#Transaction Signature failed to verify");
//			return false;
//		}		
		//TODO
		return true;
	}

	@Override
	public long getInputsValue() {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public long getOutputsValue() {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public String toString() {
		return "VotingTX [election=" + hashOfElectionTX + ", vote=" + approval + "]";
	}
	
}
