package redactableBlockchain.util;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.security.NoSuchAlgorithmException;
import java.security.Security;
import java.security.spec.InvalidKeySpecException;

import redactableBlockchain.Miner;
import redactableBlockchain.data.IBlock;
import redactableBlockchain.data.StandardBlock;

public class MineGenesisBlock {

	public static void main(String[] args) throws NoSuchAlgorithmException, InvalidKeySpecException {
		Security.addProvider(new org.bouncycastle.jce.provider.BouncyCastleProvider()); //Setup Bouncey castle as a Security Provider
		// TODO Auto-generated method stub
		Miner miner = new Miner(null, null, 0);
		
		IBlock block = Constants.getGenesisBlock();
		miner.notifyNewBlockToMine(block);
		miner.start();
		waitForEnd();
	}

	private static void waitForEnd() {
		
		boolean loop = true;
		InputStreamReader isr = null;
		BufferedReader br = null;
		try {
			isr = new InputStreamReader(System.in);
		 	br = new BufferedReader(isr);
			while (loop) {
				String userInput = br.readLine();
				System.out.println("input => "+userInput);
				if (userInput.equalsIgnoreCase("quit") || userInput.equalsIgnoreCase("exit") || userInput.equalsIgnoreCase("bye")) {
					System.exit(0);
				}
			}
		}
		catch (Exception er) {
			er.printStackTrace();
			loop = false;
		}
		finally {
			try { br.close(); } catch (Exception e) {}
			try { isr.close(); } catch (Exception e) {}
		}
			
		}
}
