import static org.junit.Assert.assertTrue;

import java.security.NoSuchAlgorithmException;
import java.security.PublicKey;
import java.security.Security;
import java.security.spec.InvalidKeySpecException;
import java.util.Arrays;
import java.util.Base64;

import org.bouncycastle.asn1.sec.ECPrivateKey;
import org.bouncycastle.jcajce.provider.asymmetric.ec.BCECPrivateKey;
import org.junit.Test;

import com.google.gson.Gson;

import redactableBlockchain.Wallet;
import redactableBlockchain.util.Utils;

public class WalletTest {

	public WalletTest() {
		Security.addProvider(new org.bouncycastle.jce.provider.BouncyCastleProvider()); //Setup Bouncey castle as a Security Provider
	}
	
	@Test
	public void testWallet()
	{
		Wallet walletA = new Wallet("test");
		
		System.out.println("0:"+walletA.getJson());
		
		String privkey = Base64.getEncoder().encodeToString(walletA.privateKey.getEncoded());
		String pubkey = Base64.getEncoder().encodeToString(walletA.getPublicKey().getEncoded());
		

		Wallet walletB = new Wallet("test");
		String privkeyB = Base64.getEncoder().encodeToString(walletB.privateKey.getEncoded());
		String pubkeyB = Base64.getEncoder().encodeToString(walletB.getPublicKey().getEncoded());
	
		assertTrue(privkey.equals(privkeyB));
		assertTrue(pubkey.equals(pubkeyB));
	}
	
	@Test
	public void encoding() throws NoSuchAlgorithmException, InvalidKeySpecException
	{
		Wallet wallet = new Wallet();
		PublicKey pub = wallet.getPublicKey();
		String tmp = Utils.PublicKeyToBase64(pub);
		
		PublicKey pub2 = Utils.PublicKeyFromBase64(tmp);	
		assertTrue(Arrays.equals(pub.getEncoded(), pub2.getEncoded()));
	}
}
